#ifndef __TURTLE__
#define __TURTLE__

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>

#undef MAX
#undef MIN
#define MAX(a,b)	((a)<(b) ? (b) : (a))
#define MIN(a,b)	((a)<(b) ? (a) : (b))
#define cp(a)		printf("cp%d\n", a);
#define MAXMEM		128

class KTurtle : public QWidget
{
		QPaintDevice *device;
		int devw, devh;
		QPixmap *pixmap;
		char *buf1, *buf2;
		char *axiom, **rules;
		int dirs, level;

		int strRewrite(char *, char **, char *);
		void render(QPaintDevice *, int, int, char *, int);
		int go();

	public:
		KTurtle(QWidget *);
		~KTurtle();

		int go(char *, char **, int, int);
		void reset();
		void setDevice(QPaintDevice *d, int w, int h)
			{ device = d; devw = w; devh = h; }
		void save(const char *);

	protected:
		void resizeEvent(QResizeEvent *);
		void paintEvent(QPaintEvent *);
};

#endif
